unit DocTranscricao;

interface
  uses sysutils,Dialogs,RichEdit,comctrls,stdctrls,Classes, NotasTranscricao,
       Multimedia;
type

    TAutorDoc = record
        Nome : String;
        Local: String;
    end;

    TEpoca = record
        DataIni : String;
        DataFim : String;
    end;


    TDocTranscricao=class(TObject)
       private
           Notas     : TNotasTranscricao;
           AutorDoc  : TAutorDoc;
           Titulo    : String[100];
           Descricao : TMemo;
           Epoca     : TEPoca;
           Categoria : String;
           Multimedia: TList;
           PalavrasChave : TMemo;
           Comentarios   : TMemo;
       public
           constructor Create();
          // function getFileNameMedia():String;
           function getAutorDocNome():String;
           function getAutorDocLocal():String;
{           function getData():String;
           function getMarcas():TComboBox;}
           function getDescricao():TMemo;
           function getCategoria():String;
           function getPalavrasChave():TMemo;
           function getComentarios():TMemo;
           function getTitulo():String;
{           procedure setFileNameMedia(FileName: String); }
           procedure setAutorDocNome(Autor:String);
           procedure setAutorDocLocal(Local: String);
          // procedure setData(Data:String);
//           procedure setMarcas(Marcas: TComboBox);
           procedure setDescricao(Descricao: TMemo);
           procedure setCategoria(Categoria: String);
           procedure setPalavrasChave(PalavrasChave: TMemo);
           procedure setComentarios(Comentarios: TMemo);
           procedure setTitulo(Titulo: String);
           procedure setNotasTranscricao(Transcritor, Email,Data: String);
           procedure setEpoca(DataIni, DataFim: String);
           procedure setTranscritor(Transcritor: String);
           procedure setEmail(Email: String);
           procedure setData(Data: String);

           procedure SaveToFile(FileName: String; MediaList: TStringList;
                                Texto: TRichEdit);

    end;




implementation
   uses Main;

   constructor TDocTranscricao.Create();
   var
      mDescricao, mPalavrasChave,
      mComentarios : TMemo;
   begin
       Notas:=TNotasTranscricao.Create;
       mDescricao:=TMemo.Create(Main.frmPrincipal);
       mPalavrasChave:=TMemo.Create(Main.frmPrincipal);
       mComentarios:=TMemo.Create(Main.frmPrincipal);
       setAutorDocNome('');
       setAutorDocLocal('');
       Notas.setAutor('');
       Notas.setEmail('');
       Notas.setData('');
       setTitulo('');
       setDescricao(mDescricao);
       setCategoria('');
       setPalavrasChave(mPalavrasChave);
       setComentarios(mComentarios);
   end;


   function TDocTranscricao.getAutorDocNome():String;
   begin
        getAutorDocNome:=self.AutorDoc.Nome;
   end;

   function TDocTranscricao.getAutorDocLocal():String;
   begin
        getAutorDocLocal:=self.AutorDoc.Local;
   end;

   function TDocTranscricao.getTitulo():String;
   begin
        getTitulo:=self.Titulo;
   end;

   function TDocTranscricao.getDescricao():TMemo;
   begin
        getDescricao:=self.Descricao;
   end;

   function TDocTranscricao.getCategoria():String;
   begin
        getCategoria:=self.Categoria;
   end;

   function TDocTranscricao.getPalavrasChave():TMemo;
   begin
        getPalavrasChave:=self.PalavrasChave;
   end;

   function TDocTranscricao.getComentarios():TMemo;
   begin
        getComentarios:=self.Comentarios;
   end;


  { /**************************** SET **********************/ }
   procedure TDocTranscricao.setAutorDocNome(Autor: String);
   begin
        self.AutorDoc.Nome:=Autor;
   end;

   procedure TDocTranscricao.setAutorDocLocal(Local: String);
   begin
        self.AutorDoc.Local:=Local;
   end;

   procedure TDocTranscricao.setEpoca(DataIni, DataFim: String);
   begin
        self.Epoca.DataIni:=DataIni;
        self.Epoca.DataFim:=DataFim;
   end;

   {procedure TDocTranscricao.setData(Data: String);
   begin
        self.Data:=Data;
   end;

   procedure TDocTranscricao.setMarcas(Marcas: TComboBox);
   begin
        self.Marcas :=Marcas;
   end;                         }

   procedure TDocTranscricao.setDescricao(Descricao: TMemo);
   begin
        self.Descricao:=Descricao;
   end;

   procedure TDocTranscricao.setCategoria(Categoria: String);
   begin
        self.Categoria:=Categoria;
   end;

   procedure TDocTranscricao.setPalavrasChave(PalavrasChave: TMemo);
   begin
        self.PalavrasChave:=PalavrasChave;
   end;

   procedure TDocTranscricao.setComentarios(Comentarios: TMemo);
   begin
        self.Comentarios:=Comentarios;
   end;

   procedure TDocTranscricao.setTitulo(Titulo: String);
   begin
        self.Titulo:=Titulo;
   end;

   procedure TDocTranscricao.setTranscritor(Transcritor: String);
   begin
        self.Notas.setAutor(Transcritor);
   end;

   procedure TDocTranscricao.setEmail(Email: String);
   begin
        self.Notas.setEmail(Email);
   end;

   procedure TDocTranscricao.setData(Data: String);
   begin
        self.Notas.setData(Data);
   end;

   procedure TDocTranscricao.setNotasTranscricao(Transcritor, Email,
                                                  Data : String);
   begin
        self.Notas.setAutor(Transcritor);
        self.Notas.setEmail(Email);
        self.Notas.setData(Data);
   end;

   procedure TDocTranscricao.SaveToFile(FileName: String; MediaList : TStringList;
               Texto:TRichEdit);
   var
      f : TextFile;
      i,j : integer;
      x : String;
      media : TMultimedia;
   begin
        Assign(f,FileName);
        rewrite(f);
        writeln(f,'<?xml version = "1.0" encoding = "ISO-8859-1"?>');
        writeln(f,'<ESCRIBA VERSAO="1.0">');
        writeln(f,'   <TRANSCRICAO>');
        writeln(f,'       <AUTOR>'+self.Notas.getAutor()+'</AUTOR>');
        writeln(f,'       <EMAIL>'+self.Notas.getEmail()+'</EMAIL>');
        writeln(f,'       <DATA>'+self.Notas.getData()+'</DATA>');
        writeln(f,'   </TRANSCRICAO>');
        writeln(f,'   <DOCUMENTO>');
        writeln(f,'        <AUTOR>');
        writeln(f,'           <NOME>'+self.AutorDoc.Nome+'</NOME>');
        writeln(f,'           <LOCAL>'+self.AutorDoc.Local+'</LOCAL>');
        writeln(f,'        </AUTOR>');
        writeln(f,'        <TITULO>'+self.Titulo+'</TITULO>');
        writeln(f,'        <CATEGORIA>'+self.Categoria+'</CATEGORIA>');
        writeln(f,'        <DESCRICAO>'+self.Descricao.Text+'</DESCRICAO>');
        writeln(f,'        <EPOCA>');
        writeln(f,'          <DATA>'+self.Epoca.DataIni+'</DATA>');
        writeln(f,'          <DATA>'+self.Epoca.DataFim+'</DATA>');
        writeln(f,'        </EPOCA>');
        writeln(f,'        <MULTIMEDIA>');
        for i:=0 to MediaList.Count -1 do
        begin
            media := TMultimedia(MediaList.Objects[i]);
            with media do
            begin
              writeln(f,'     <'+Tipo+' Formato="'+getFormato()+'">');
              writeln(f,'        <FICHEIRO>'+getFileName+'</FICHEIRO>');
              if Marcas.Count <> 0 then
                 writeln(f,'        <MARCAS>');
              for j:=0 to Marcas.Count-1 do
              begin
                 str(Cardinal(Marcas.Objects[j]),x);
                 Write(f,'      <MARCA Posicao="'+x+'">');
                 Writeln(f,Marcas.Strings[j]+'</MARCA>');
              end;
              if Marcas.Count <>0 then
                 writeln(f,'        </MARCAS>');
              writeln(f,'     </'+Tipo+'>');
            end;
        end;
        writeln(f,'    </MULTIMEDIA>');
        writeln(f,'    <PALCHAVE>'+self.PalavrasChave.Text+'</PALCHAVE>');
        writeln(f,'    <COMENTARIOS>'+self.Comentarios.Text+'</COMENTARIOS>');
        writeln(f,'    <TEXTO>');
        writeln(f,Texto.Lines.Text);
        writeln(f,'    </TEXTO>');
        writeln(f,'  </DOCUMENTO>');
        writeln(f,'</ESCRIBA>');
        close(f);
   end;



end.